

@template top
	.bg-1
		.top.t-1.app__row
			.right.lang &each: lng in _.list
				a.hand - {lng|upper} -
					&on:"click", _.setLang.bind(null, lng)
					&class:"selected", lng == _.current
					&class:"lang-" + lng
			a[href="#home"].home-link Header
	.bg-2
		.menu.app__row
			@template nav-row
				a.menu__item
					&class:"selected", (location.href.split("#")[1]||View.home).indexOf(this.href.split('#')[1]) == 0
			nav-row[href="#home"] Home
			nav-row[href="#users"] Users
			nav-row[href="#settings"] Settings
			nav-row[href="#test"] Test

@template footer
	.bg-1
		.footer.app__row.grid.pad-3.c2
			.footer__item.col-4
				dt litejs.com
				dd>a[href="#help"] How to use
				dd>a[href="#privacy"] Privacy
			.footer__item.col-4
				dt Contacts
				dd>a[href="mailto:mail@to.com"] email

@template confirm
	.modal.abs.max.fix
		.abs.max.modal__background
		.grid.pad-1.modal__content
			.col-12 {title}
			.col-12 {body}
			.col-6>.btn Cancel
			.col-6>.btn Ok

@view #public #body .content
	.app.max-height
		top
		.content.loader.app__row
		.footer__spacer
	footer

@view #private #body .content
	.app.max-height
		button.top__logout.right Logout
			&on:"click", "logout"
		top
		.content.loader.app__row
		.footer__spacer
	footer

@view 404 #public
	h2 Error 404
	| Page not found.
	| Maybe you want to look something else?

@view home #public
	h2 Home
	div _welcome
		&on: "click", Fn("this.style.fontStyle = this.style.fontStyle == 'italic' ? '' : 'italic'")
	div &txt: _("_welcome")
		&on: "mouseover", Fn("this.addClass('bg3'),this.txt(this.txt() == _('_welcome') ? 'Over!' : _('_welcome'))")
		&on: "mouseout", Fn("this.rmClass('bg3'),this.txt(_('_welcome'))")
	div &txt: _(welcomeText)
	div &txt: _(nonExistingWelcomeText)
	.time
		&txt: started.format()
	.time
		&txt: new Date().format()

@view login #public
	form[action="javascript:"][method=POST] &emitForm:"login"
		fieldset.grid.pad-2.login
			legend Login
			label.col-12
				.col-12.col-md-4.login__label Username
				input.col-12.col-md-8[name=name]
			label.col-12
				.col-12.col-md-4.login__label Password
				input.col-12.col-md-8[name=pass][type=password]
			.col-12
				.col-12.col-md-4
				input.btn.col-12.col-md-8[type=submit] Log In


@view users #public
	h2 Users
	ul.users &list: Data("users")
		li
			a
				&txt: item.name
				&href: "#users/" + item.id

@view users/{id} #public
	h2 User #{route.id}

@view test #public
	h2 Test
	ul
		li>a[href="#testman"] Testman
		li>a[href="#broken-link"] Test broken link
		li>a[href="#test-form1"] Test form
		li>a[href="#test-grid"] Test grid
	@rel user home vnd.app.home
		.home {home.name}
	@rel user home vnd.app.home.v2
		.home {home.homeName}

