

JSON.serializeForm = function(form) {
	var el, step, key, value
	, res = {}
	, i = 0

	// Disabled controls do not receive focus,
	// are skipped in tabbing navigation, cannot be successfully posted.
	//
	// Read-only elements receive focus but cannot be modified by the user,
	// are included in tabbing navigation, are successfully posted.
	//
	// Read-only checkboxes can be changed by the user
	//

	for (; el = form.elements[i++]; ) if (!el.disabled && (key = el.name || el.id)) {
		value = el.val()
		if (value != null) {
			step = res
			key.replace(/\[(.*?)\]/g, function(_, _key, offset) {
				if (step == res) key = key.slice(0, offset)
				step = step[key] || (step[key] = _key && +_key != _key ? {} : [])
				key = _key
			})
			step[key || step.length] = value
		}
	}

	return res
}


