


/*
 * @version    0.3.8
 * @date       2014-09-19
 * @stability  1 - Experimental
 * @author     Lauri Rooden <lauri@rooden.ee>
 * @license    MIT License
 */

/*
+--------+----------+
| Class  | Width    |
+========+==========+
| xs     |          | .col-xs-
| sm     | 0-600    |
| md     | 601-1024 |
| lg     | 1025-    |
| xl     |          |
+--------+----------+
*/

!function(window) {
	var lastSize, lastOrient
	, node = document.documentElement
	, proto = El.prototype
	, emit = function() {
		if (window.M) M.emit("resize")
	}.rate(200, true)

	function swapClass(rm, add) {
		proto.rmClass.call(node, rm)
		proto.addClass.call(node, add)
	}

	function setClasses() {
		// document.documentElement.clientWidth is 0 in IE5
		var width = node.offsetWidth
		, next = width < 601 ? "sm" : width < 1025 ? "md" : "lg"

		if ( next != lastSize ) {
			swapClass(lastSize, lastSize = next)
		}

		next = width > node.offsetHeight ? "landscape" : "portrait"

		if ( next != lastOrient) {
			swapClass(lastOrient, lastOrient = next)
		}
		emit()
	}
	setClasses()

	Event.add(window, "resize", setClasses)
	Event.add(window, "orientationchange", setClasses)
	Event.add(window, "load", setClasses)
}(this)

